#ifndef _AVR_DEFINES_HPP
#define _AVR_DEFINES_HPP

// ATmega103comp: usarts=1; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega103comp__
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega103comp__

// ATmega103: usarts=0; uarts=1; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega103__
#define HAS_UART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega103__

// ATmega1280: usarts=4; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega1280__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_USART2
#define HAS_USART3
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega1280__

// ATmega1281: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega1281__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega1281__

// ATmega1284P: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega1284P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega1284P__

// ATmega1284: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega1284__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega1284__

// ATmega128A: usarts=2; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega128A__
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega128A__

// ATmega128RFA1: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega128RFA1__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega128RFA1__

// ATmega128: usarts=2; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega128__
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega128__

// ATmega161comp: usarts=2; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega161comp__
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega161comp__

// ATmega161: usarts=2; uarts=2; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega161__
#define HAS_USART0
#define HAS_USART1
#define HAS_UART0
#define HAS_UART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega161__

// ATmega162: usarts=2; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega162__
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega162__

// ATmega163: usarts=0; uarts=1; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega163__
#define HAS_UART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega163__

// ATmega164A: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega164A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega164A__

// ATmega164PA: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega164PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega164PA__

// ATmega164P: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega164P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega164P__

// ATmega165A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega165A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega165A__

// ATmega165PA: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega165PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega165PA__

// ATmega165P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega165P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega165P__

// ATmega165: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega165__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega165__

// ATmega168A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega168A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega168A__

// ATmega168PA: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega168PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega168PA__

// ATmega168P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega168P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega168P__

// ATmega168: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega168__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega168__

// ATmega169A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega169A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega169A__

// ATmega169PA: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega169PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega169PA__

// ATmega169P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega169P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega169P__

// ATmega169: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega169__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega169__

// ATmega16A: usarts=1; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega16A__
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega16A__

// ATmega16HVA2: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega16HVA2__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega16HVA2__

// ATmega16HVA: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega16HVA__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega16HVA__

// ATmega16HVB: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega16HVB__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega16HVB__

// ATmega16M1: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega16M1__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega16M1__

// ATmega16U2: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega16U2__
#define CAN_TOGGLE_PIN 1
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega16U2__

// ATmega16U4: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega16U4__
#define CAN_TOGGLE_PIN 1
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega16U4__

// ATmega16: usarts=1; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega16__
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega16__

// ATmega2560: usarts=4; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega2560__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_USART2
#define HAS_USART3
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega2560__

// ATmega2561: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega2561__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega2561__

// ATmega323: usarts=1; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega323__
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega323__

// ATmega324A: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega324A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega324A__

// ATmega324PA: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega324PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega324PA__

// ATmega324P: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega324P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega324P__

// ATmega3250PA: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega3250PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega3250PA__

// ATmega3250P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega3250P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega3250P__

// ATmega3250: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega3250__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega3250__

// ATmega325A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega325A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega325A__

// ATmega325PA: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega325PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega325PA__

// ATmega325P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega325P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega325P__

// ATmega325: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega325__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega325__

// ATmega328P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega328P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega328P__

// ATmega328: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega328__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega328__

// ATmega3290PA: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega3290PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega3290PA__

// ATmega3290P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega3290P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega3290P__

// ATmega3290: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega3290__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega3290__

// ATmega329A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega329A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega329A__

// ATmega329PA: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega329PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega329PA__

// ATmega329P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega329P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega329P__

// ATmega329: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega329__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega329__

// ATmega32A: usarts=1; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega32A__
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega32A__

// ATmega32C1: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega32C1__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega32C1__

// ATmega32HVB: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega32HVB__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega32HVB__

// ATmega32M1: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega32M1__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega32M1__

// ATmega32U2: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega32U2__
#define CAN_TOGGLE_PIN 1
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega32U2__

// ATmega32U4: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega32U4__
#define CAN_TOGGLE_PIN 1
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega32U4__

// ATmega32U6: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega32U6__
#define CAN_TOGGLE_PIN 1
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega32U6__

// ATmega32: usarts=1; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega32__
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega32__

// ATmega406: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega406__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega406__

// ATmega48A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega48A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega48A__

// ATmega48PA: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega48PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega48PA__

// ATmega48P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega48P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega48P__

// ATmega48: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega48__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega48__

// ATmega640: usarts=4; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega640__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_USART2
#define HAS_USART3
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega640__

// ATmega644A: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega644A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega644A__

// ATmega644PA: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega644PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega644PA__

// ATmega644P: usarts=2; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega644P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega644P__

// ATmega644: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega644__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega644__

// ATmega6450A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega6450A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega6450A__

// ATmega6450: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega6450__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega6450__

// ATmega645A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega645A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega645A__

// ATmega645: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega645__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega645__

// ATmega6490A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega6490A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega6490A__

// ATmega6490P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega6490P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega6490P__

// ATmega6490: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega6490__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega6490__

// ATmega649A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega649A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega649A__

// ATmega649P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega649P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega649P__

// ATmega649: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega649__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega649__

// ATmega64A: usarts=2; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega64A__
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega64A__

// ATmega64C1: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega64C1__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega64C1__

// ATmega64HVE: usarts=0; uarts=0; pues=0; tgl_pin=False; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega64HVE__
#define HAS_TIMER0 16
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega64HVE__

// ATmega64M1: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega64M1__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega64M1__

// ATmega64: usarts=2; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega64__
#define HAS_USART0
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega64__

// ATmega8515: usarts=1; uarts=0; pues=0; tgl_pin=False; timers=2 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega8515__
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega8515__

// ATmega8535: usarts=1; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega8535__
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega8535__

// ATmega88A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega88A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega88A__

// ATmega88PA: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega88PA__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega88PA__

// ATmega88P: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega88P__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega88P__

// ATmega88: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=3 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega88__
#define CAN_TOGGLE_PIN 1
#define HAS_USART0
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega88__

// ATmega8A: usarts=1; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega8A__
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega8A__

// ATmega8HVA: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega8HVA__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega8HVA__

// ATmega8U2: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATmega8U2__
#define CAN_TOGGLE_PIN 1
#define HAS_USART1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATmega8U2__

// ATmega8: usarts=1; uarts=0; pues=0; tgl_pin=False; timers=3 (separate: False, tccr0a: False)
#ifdef __AVR_ATmega8__
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_TIMER2 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATmega8__

// ATtiny10: usarts=0; uarts=0; pues=1; tgl_pin=False; timers=1 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny10__
#define HAS_PUEB
#define HAS_TIMER0 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny10__

// ATtiny11: usarts=0; uarts=0; pues=0; tgl_pin=False; timers=1 (separate: False, tccr0a: False)
#ifdef __AVR_ATtiny11__
#define HAS_TIMER0 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATtiny11__

// ATtiny12: usarts=0; uarts=0; pues=0; tgl_pin=False; timers=1 (separate: False, tccr0a: False)
#ifdef __AVR_ATtiny12__
#define HAS_TIMER0 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATtiny12__

// ATtiny13A: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=1 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny13A__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny13A__

// ATtiny13: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=1 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny13__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny13__

// ATtiny15: usarts=0; uarts=0; pues=0; tgl_pin=False; timers=2 (separate: False, tccr0a: False)
#ifdef __AVR_ATtiny15__
#define HAS_TIMER0 8
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATtiny15__

// ATtiny1634: usarts=2; uarts=0; pues=3; tgl_pin=False; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny1634__
#define HAS_USART0
#define HAS_USART1
#define HAS_PUEA
#define HAS_PUEB
#define HAS_PUEC
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny1634__

// ATtiny167: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny167__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny167__

// ATtiny20: usarts=0; uarts=0; pues=2; tgl_pin=False; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny20__
#define HAS_PUEA
#define HAS_PUEB
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny20__

// ATtiny22: usarts=0; uarts=0; pues=0; tgl_pin=False; timers=1 (separate: False, tccr0a: False)
#ifdef __AVR_ATtiny22__
#define HAS_TIMER0 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATtiny22__

// ATtiny2313A: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny2313A__
#define CAN_TOGGLE_PIN 1
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny2313A__

// ATtiny2313: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny2313__
#define CAN_TOGGLE_PIN 1
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny2313__

// ATtiny24A: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny24A__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny24A__

// ATtiny24: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny24__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny24__

// ATtiny25: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny25__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny25__

// ATtiny261A: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny261A__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny261A__

// ATtiny261: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny261__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny261__

// ATtiny26: usarts=0; uarts=0; pues=0; tgl_pin=False; timers=2 (separate: False, tccr0a: False)
#ifdef __AVR_ATtiny26__
#define HAS_TIMER0 8
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATtiny26__

// ATtiny28: usarts=0; uarts=0; pues=0; tgl_pin=False; timers=1 (separate: False, tccr0a: False)
#ifdef __AVR_ATtiny28__
#define HAS_TIMER0 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 0
#endif // __AVR_ATtiny28__

// ATtiny40: usarts=0; uarts=0; pues=3; tgl_pin=False; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny40__
#define HAS_PUEA
#define HAS_PUEB
#define HAS_PUEC
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny40__

// ATtiny4313: usarts=1; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny4313__
#define CAN_TOGGLE_PIN 1
#define HAS_USART
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny4313__

// ATtiny43U: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny43U__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny43U__

// ATtiny44A: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny44A__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny44A__

// ATtiny44: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny44__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny44__

// ATtiny45: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny45__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny45__

// ATtiny461A: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny461A__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny461A__

// ATtiny461: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny461__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny461__

// ATtiny48: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny48__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny48__

// ATtiny4: usarts=0; uarts=0; pues=1; tgl_pin=False; timers=1 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny4__
#define HAS_PUEB
#define HAS_TIMER0 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny4__

// ATtiny5: usarts=0; uarts=0; pues=1; tgl_pin=False; timers=1 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny5__
#define HAS_PUEB
#define HAS_TIMER0 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny5__

// ATtiny84A: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny84A__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny84A__

// ATtiny84: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny84__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny84__

// ATtiny85: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny85__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny85__

// ATtiny861A: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny861A__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny861A__

// ATtiny861: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: False, tccr0a: True)
#ifdef __AVR_ATtiny861__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 16
#define HAS_TIMER1 8
#define HAS_SEPARATE_TIMER_REGISTERS 0
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny861__

// ATtiny87: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny87__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny87__

// ATtiny88: usarts=0; uarts=0; pues=0; tgl_pin=True; timers=2 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny88__
#define CAN_TOGGLE_PIN 1
#define HAS_TIMER0 8
#define HAS_TIMER1 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny88__

// ATtiny9: usarts=0; uarts=0; pues=1; tgl_pin=False; timers=1 (separate: True, tccr0a: True)
#ifdef __AVR_ATtiny9__
#define HAS_PUEB
#define HAS_TIMER0 16
#define HAS_SEPARATE_TIMER_REGISTERS 1
#define HAS_TCCR0A_TIMER_REGISTER 1
#endif // __AVR_ATtiny9__

#endif // _AVR_DEFINES_HPP
