#ifndef _HAL_HPP
#define _HAL_HPP

#include "Reg.hpp"
#include "Pin.hpp"


class Ausgabe: public OutputPin {
public:
    Ausgabe(volatile uint8_t* ddr, volatile uint8_t* port, 
           volatile uint8_t* pin, uint8_t num):
        OutputPin(ddr, port, pin, num) {}
    void ein(void) { this->setHigh(); }
    void aus(void) { this->setLow(); }
};

typedef Ausgabe Motor;
typedef Ausgabe Beleuchtung;


class Eingabe: public InputPin {
public:
    Eingabe(volatile uint8_t* ddr, volatile uint8_t* port, 
           volatile uint8_t* pin, uint8_t num):
        InputPin(ddr, port, pin, num) {}
    int gedrueckt(void) { return this->isHigh(); }
};

typedef Eingabe Startknopf;
typedef Eingabe Bremse;


class Getriebe: public InputPin {
public:
    Getriebe(volatile uint8_t* ddr, volatile uint8_t* port, 
           volatile uint8_t* pin, uint8_t num):
        InputPin(ddr, port, pin, num) {}
    int eingelegt(void) { return this->isHigh(); }
};

#endif // _HAL_HPP
